import React,{Fragment} from 'react';
import moment from 'moment';
import { withRouter } from "react-router-dom";
import ItemNav from "../../components/ItemNav";
import ItemTableQuery from "../../components/ItemTableQuery";
import ItemTable from "../../components/ItemTable";
import HttpClient from "../../service/HttpClient";
import Api from "../../service/Api";
import { set, get } from "../../service/Global";
import {Tag, Button, Empty, Modal, Table, Input,Form, Select,Popconfirm,message} from 'antd';
import {dateFormat, parseParams} from "../../service/utils";
import {Store} from "marine";
const { TextArea } = Input;
@withRouter
 class MonitorManger extends React.Component{
  constructor(props){
    super(props);
    this.state={
      visible: false,
      platData:[],
      channelData:[],
      dataSource:{},
      list:{}
    }
  }
  form;
  defaultParams = {
    page:1,
    pageSize:10
  };
  itemNav = {
    list: [{ anchor: "通知管理人" }],
  };
  columns = [
    { title: "平台名称", dataIndex: "platform", key: "platform",},
    { title: "渠道名称", dataIndex: "channel", key: "channel" },
    { title: "姓名", dataIndex: "name", key: "name" },
    { title: "手机号", dataIndex: "phone", key: "phone", },
    { title: "状态", dataIndex: "statusName", key: "statusName",},
    { title: "操作人", dataIndex: "optionUser", key: "optionUser",},
    { title: "更新时间", dataIndex: "createdAt", key: "createdAt",},
    { title: "操作", dataIndex: "operate", key: "operate",render:(text,record)=>{
      return <div>
        <Button type='link' onClick={()=>{this.showBatchModal(record)}}>修改</Button>
        <Button type='link start-color' onClick={()=>{this.setStatus(record)}}>{record.status==1?'禁用':'启用'}</Button>
        <Popconfirm
        title="你确定删除吗?"
        onConfirm={()=>{this.handleDelete(record.id)}}
        //onCancel={this.cancel}
        okText="Yes"
        cancelText="No"
        >
          <Button type='link ml-20 delete-red' >删除</Button>
        </Popconfirm>
        
      </div>
    }},
  ];
  setStatus=(record)=>{
    return HttpClient.post(Api.peopleStatus,{id:record.id,status:record.status==1?2:1}).then(data => {
      if(data){
        message.success('操作成功！');
        this.getList(this.defaultParams)
      }
    })
  }
  handleDelete=(id)=>{
    return HttpClient.post(Api.peopleDelete,{id:id}).then(data => {
        if(data){
            message.success('删除成功！');
            this.getList(this.defaultParams)
        }
        
        
        // this.setState({
        //   dataSource: data,
        // })
      })
  }
  getList(params){
    return HttpClient.post(Api.peopleList,{...params,}).then(data => {
      this.setState({
        dataSource: data,
      })
    })
  }

  getPlatList(){
    return HttpClient.post(Api.platformList).then(data => {
      let tmp=[]
      for(var i in data){
        let obj= {id:i,name:data[i]}
          tmp.push(obj)
        
      }
      this.setState({
        platData:tmp
      })
    })
  }
  channelList=()=>{
    return HttpClient.post(Api.channelList).then(data => {
      let tmp=[]
      for(var i in data){
        let obj= {id:i,name:data[i]}
        tmp.push(obj)
      }
      this.setState({
        channelData:tmp
      })
    })
  }
  
  
  pager = (page) => {
    this.defaultParams = Object.assign({},this.defaultParams,{page:page});
    this.getList(this.defaultParams);
  };
  onShowSizeChange=(current, pageSize)=> {
    this.defaultParams = Object.assign({},this.defaultParams,{page:current,pageSize:pageSize});
    this.getList(this.defaultParams);
  }
  getTableQuery=(params)=>{
    if(params['range_picker']){
      const [startTime,endTime] = params['range_picker'];
      this.defaultParams = Object.assign(this.defaultParams,{startTime,endTime},{...params});
    }else {
      this.defaultParams = Object.assign(this.defaultParams,{...params});
    }
    delete this.defaultParams.range_picker;
    this.getList(this.defaultParams);
  };
  resetParams = ()=>{
    this.defaultParams = {};
    this.setState({
      tableData:{}
    })
  };

  handleCancel = () => {
    this.setState({ visible: false });
  };
  handleOk=()=>{
    const id=this.state.list.id;
    this.props.form.validateFields((err, values) => {
      if (!err) {
        console.log('Received values of form: ', values);
        if(id){
          HttpClient.post(Api.peopleEdit,{...values,id:id}).then(data => {
           
            this.setState({ visible: false });
            this.getList(this.defaultParams)
           })
        }else{
          HttpClient.post(Api.peopleAdd,{...values}).then(data => {
           
            this.setState({ visible: false });
            this.getList(this.defaultParams)
           })
        }
       
      }
    });

  }
 
 
  showBatchModal = (list) => {
    if(list){
      this.setState({visible: true,list});
    }else{

      this.setState({visible: true,list:{}});
    }
   
  };
 

  componentDidMount() {
    this.getPlatList();
    this.channelList();
    this.getList(this.defaultParams)
  }

  render() {
    const {platData,channelData,list}=this.state;
    const itemTableQuery= [
         
      {
        label:'选择日期',
        type: "range_picker",
        key: "date",   

      },
      {
        label:'所属平台',
        type:'select',
        key:'platform',
       // mode:'multiple',
        placeholder:'全部',
        data:platData,
          
      },
     
      {
        type:'input',
        key:'key',
       placeholder:'请输入姓名'
      },
     
      {
        type: "submit",
        extend: false,
        render: <Fragment>
           
          </Fragment>,
      },
    ];
    const { getFieldDecorator } = this.props.form;
    const formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 8 },
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
      },
    };
   
    return(
      <Fragment>
            <ItemNav itemNav={this.itemNav} />
            <section className='content-base'>
          <div className='mb-20 formwrapper'>
            <div className='formBg'><ItemTableQuery getTableQuery={this.getTableQuery} resetParams={this.resetParams} itemTableQuery={itemTableQuery} /></div> 
            <Button type='primary' className='ml-20' onClick={()=> this.showBatchModal()}>添加管理员</Button>
          </div>
         
          <ItemTable columns={this.columns} dataSource={this.state.dataSource} pager={this.pager} onShowSizeChange={this.onShowSizeChange}/>
        </section>
        <Modal  title="添加管理员"
          visible={this.state.visible}
          onOk={this.handleOk}
          onCancel={this.handleCancel}>
            <Form {...formItemLayout} >
                <Form.Item label="所属平台">
              {getFieldDecorator('platform', {
                initialValue:list.platformId?list.platformId.toString():"0",
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                  <Select>
                    {
                      platData&&platData.map((item,i)=>{
                        return <Select.Option value={item.id} key={i}>{item.name}</Select.Option>
                      })
                    }
                    
                  </Select>
                )}
              </Form.Item>
              <Form.Item label="所属渠道">
              {getFieldDecorator('channel', {
                 initialValue:list.channelId?list.channelId.toString():'0',
                rules: [
                 
                  {
                    required: true,
                    message: '请选择',
                  },
                 
                ],
                })(
                  <Select >
                    {
                      channelData&&channelData.map((item,i)=>{
                        return <Select.Option value={item.id} key={i}>{item.name}</Select.Option>
                      })
                    }
                  </Select>
                )}
              </Form.Item>
              
             
              <Form.Item label="真实姓名">
              {getFieldDecorator('remarkName', {
                initialValue:list?list.name:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
              <Form.Item label="手机号">
              {getFieldDecorator('phone', {
                initialValue:list?list.phone:'',
                rules: [
                  {
                    required: true,
                    message: '请选择',
                  },
                ],
                })(
                <Input/>
                )}
              </Form.Item>
             
            </Form>
        </Modal>
      </Fragment>
    )
  }
}
export default Form.create()(MonitorManger)